int TAILLE_MAP=256/8;               //Taille de la carte de l'cran
unsigned short tableau[22][32];
TypeSprite MonOAM[128];

//Inutilis
void CopieMap_8(const unsigned short *map, int tailleX, int tailleY, int largeurEcran)        {
    int x,y;
    for (y=0;y<tailleY;y++)
        for (x=0;x<tailleX;x++)
            *((unsigned short*)ScreenBaseBlock(31)+y*largeurEcran+x)=*(map+y*tailleX+x);
}

//Copie un bloc de 16x16 pixels sur une map de 8x8
inline void CopieBloc_16(int x, int y, unsigned short bloc)      {
    bloc<<=2;
    tableau[2*y][2*x]=bloc;
    tableau[2*y][2*x+1]=bloc+1;
    tableau[2*y+1][2*x]=bloc+2;
    tableau[2*y+1][2*x+1]=bloc+3;
}

//Et a directement sur l'cran
/*void CopieBloc_16(int x, int y, unsigned short bloc)      {
    bloc<<=2;               //bloc=bloc*4 plus rapide
    *((unsigned short*)ScreenBaseBlock(31)+2*y*TAILLE_MAP+2*x)=bloc;
    *((unsigned short*)ScreenBaseBlock(31)+2*y*TAILLE_MAP+2*x+1)=bloc+1;
    *((unsigned short*)ScreenBaseBlock(31)+(2*y+1)*TAILLE_MAP+2*x)=bloc+2;
    *((unsigned short*)ScreenBaseBlock(31)+(2*y+1)*TAILLE_MAP+2*x+1)=bloc+3;
}*/

//Copie un morceau de map en fonction des paramtres. Reste  dplacer a dans la mmoire
//Vido  la fin
void CopieMap_16(const unsigned short *map, int departX, int departY, int tailleX, int tailleY, int tailleMapX, int tailleMapY, int largeurEcran)        {
    int x,y;
    unsigned short *ptr;

    if (tailleX>240/16+1)
        tailleX=240/16+1;
    if (tailleY>160/16+1)
        tailleY=160/16+1;

    for (y=0;y<tailleY;y++)     {
        ptr=(unsigned short *)(map+(y+departY)*tailleMapX+departX);
        for (x=0;x<tailleX;x++)     {
            if (y+departY<0 || x+departX<0 || y+departY>=tailleMapY || x+departX>=tailleMapX)     {
                CopieBloc_16(x,y,0);
            }
            else    {
                CopieBloc_16(x,y,*ptr);
            }
            ptr++;
        }
    }
}

//Dessine du texte
void DessTexte(int x, int y, char *texte)       {
    while(*texte)        {
        *((unsigned short*)ScreenBaseBlock(30)+y*TAILLE_MAP+x)=(*texte)-32;
        x++;
        texte++;
    }
}

//Car -1/16 ne semble pas valoir -1, ce qui serait cens tre le cas :|
int divisionEntiere(nombre,diviseur)     {
    return nombre/diviseur-(nombre>=0?0:1);
}

//Reste de la division entire, avec support correct pour les nombres ngatifs.
int modulo(nombre,diviseur)     {
    return (nombre-divisionEntiere(nombre,diviseur)*diviseur);
}

//unsigned short *map=sol_nv1_map;
#include "sprites.h"

void AfficheMario(SPRITE *perso, int scrlX, int scrlY)        {
    int i,j;
    PositionRelativeObjet16x16(perso->x,perso->y,scrlX,scrlY,&i,&j);
    PlaceObjetXY(0,i,j);
    if (perso->saut>0)     {
        ChangeTileObjet(0,6<<3);
    }
    else if (perso->vitesse!=0 && !interdit.ft.SECOND)      {
        if (perso->cpt%8>=4)        {
            ChangeTileObjet(0,4<<3);
        }
        else    {
            ChangeTileObjet(0,5<<3);
        }
    }
    else    {
        ChangeTileObjet(0,0<<3);
    }
    if (perso->dir==1)      {
        RetourneObjetH_Non(0);
    }
    else    {
        RetourneObjetH_Oui(0);
    }
    perso->cpt++;
}

//#define Collision(x,y)      (Map((x)/16,(y)/16))

void GereScrolling(SPRITE *mario, int *scrlX, int *scrlY)        {
    int i,j;
    
    i=mario->x-(*scrlX);
    j=mario->y-(*scrlY);
    if (i<70)
        (*scrlX)-=70-i;
    if (i>104)
        (*scrlX)+=i-104;
    if (j<50)
        (*scrlY)-=50-j;
    if (j>94)
        (*scrlY)+=j-94;
    if (*scrlX<0)
        *scrlX=0;
    if (*scrlY<0)
        *scrlY=0;
    if (*scrlX>TILE*100-240)
        *scrlX=TILE*100-240;
    if (*scrlY>TILE*16-160)
        *scrlY=TILE*16-160;
}

